-- name: [CS] Marvel Pals
-- description: All your favorites!

local E_MODEL_SPIDEY = smlua_model_util_get_id("spidey_geo")
local E_MODEL_SYMBIOTE = smlua_model_util_get_id("symbiote_geo")
local E_MODEL_BEN = smlua_model_util_get_id("ben_geo")
local E_MODEL_BAGMAN = smlua_model_util_get_id("bagman_geo")

local E_MODEL_WOLVERINE = smlua_model_util_get_id("wolverine_geo")
local E_MODEL_BAT = smlua_model_util_get_id("bat_geo")
local E_MODEL_WFORCE = smlua_model_util_get_id("wforce_geo")
local E_MODEL_TANK = smlua_model_util_get_id("tank_geo")

local E_MODEL_HULK = smlua_model_util_get_id("hulk_geo")
local E_MODEL_GREY = smlua_model_util_get_id("grey_geo")
local E_MODEL_RED = smlua_model_util_get_id("red_geo")

local E_MODEL_DEADPOOL = smlua_model_util_get_id("deadpool_geo")
local E_MODEL_TRAINEE = smlua_model_util_get_id("trainee_geo")
local E_MODEL_XFORCE = smlua_model_util_get_id("xforce_geo")  
local E_MODEL_BLACK = smlua_model_util_get_id("black_geo") 
local E_MODEL_COOLPOOL = smlua_model_util_get_id("coolpool_geo")

local E_MODEL_VENOM = smlua_model_util_get_id("venom_geo")
local E_MODEL_MVC = smlua_model_util_get_id("mvc_geo")

local E_MODEL_DAREDEVIL = smlua_model_util_get_id("daredevil_geo")
local E_MODEL_KAM = smlua_model_util_get_id("kam_geo")
local E_MODEL_SHADOWLAND = smlua_model_util_get_id("shadowland_geo")

local E_MODEL_CHIMICHANGA = smlua_model_util_get_id("chimichanga_geo")

local TEX_SM_LIFE_ICON = get_texture_info("sm-life")
local TEX_WV_LIFE_ICON = get_texture_info("wv-life")
local TEX_HK_LIFE_ICON = get_texture_info("hk-life")
local TEX_DP_LIFE_ICON = get_texture_info("dp-life")
local TEX_VM_LIFE_ICON = get_texture_info("vm-life")
local TEX_DD_LIFE_ICON = get_texture_info("dd-life")

local TEX_DP_STAR_ICON = get_texture_info("dp-star")

local TEXT_MOD_NAME = "MARVEL PALS"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local VOICETABLE_SPIDEY = {
    [CHAR_SOUND_ATTACKED] = 'SM-Hurt1.ogg',
    [CHAR_SOUND_DOH] = 'SM-Hurt2.ogg',
    [CHAR_SOUND_DROWNING] = 'SM-RodeoClown.ogg',
    [CHAR_SOUND_DYING] = 'SM-RodeoClown.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'SM-Woosh.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'SM-Jump1.ogg',
    [CHAR_SOUND_HOOHOO] = 'SM-Jump2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'SM-Flip.ogg',
    [CHAR_SOUND_HAHA] = 'SM-Autographs.ogg',
    [CHAR_SOUND_YAHOO] = 'SM-Woow.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'SM-Woow.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'SM-PizzaTime.ogg',
    [CHAR_SOUND_OOOF] = 'SM-MyBack.ogg',
    [CHAR_SOUND_OOOF2] = 'SM-Myback.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'SM-MyBack2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'SM-Scream.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'SM-Punch1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'SM-Punch2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'SM-Punch3.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'SM-Chump.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'SM-Scream.ogg',
    [CHAR_SOUND_HRMM] = 'SM-WebGrab.ogg',
    [CHAR_SOUND_WAH2] = 'SM-Throw.ogg',
    [CHAR_SOUND_WHOA] = 'SM-WebGrab.ogg',
    [CHAR_SOUND_YAWNING] = 'SM-HavingFun.ogg',
}

local VOICETABLE_WOLVERINE = {
    [CHAR_SOUND_ATTACKED] = 'WV-Hurt2.ogg',
    [CHAR_SOUND_DOH] = 'WV-Hurt.ogg',
    [CHAR_SOUND_DROWNING] = 'WV-Dying.ogg',
    [CHAR_SOUND_DYING] = 'WV-Dying.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'WV-Oof.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'WV-Jump1.ogg',
    [CHAR_SOUND_HOOHOO] = 'WV-Jump2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'WV-Jump3.ogg',
    [CHAR_SOUND_HAHA] = 'WV-Work.ogg',
    [CHAR_SOUND_YAHOO] = 'WV-LongJump.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'WV-LongJump.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'WV-Great.ogg',
    [CHAR_SOUND_OOOF] = 'WV-AwHell.ogg',
    [CHAR_SOUND_OOOF2] = 'WV-AwHell.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'WV-Wth.ogg',
    [CHAR_SOUND_ON_FIRE] = 'WV-Burning.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'WV-Yah.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'WV-Wah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'WV-Hoo.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'WV-ThickSkull.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'WV-BigFall.ogg',
    [CHAR_SOUND_WHOA] = 'WV-Grab.ogg',
}

local VOICETABLE_HULK = {
    [CHAR_SOUND_ATTACKED] = 'hk-ow.ogg',
    [CHAR_SOUND_DOH] = 'hk-ouh.ogg',
    [CHAR_SOUND_DROWNING] = 'hk-whylose.ogg',
    [CHAR_SOUND_DYING] = 'hk-whylose.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'hk-hulksmash.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'hk-grah.ogg',
    [CHAR_SOUND_HOOHOO] = 'hk-haah.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'hk-smash.ogg',
    [CHAR_SOUND_HAHA] = 'hk-throw.ogg',
    [CHAR_SOUND_YAHOO] = 'hk-lift.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'hk-lift.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'hk-star.ogg',
    [CHAR_SOUND_OOOF] = 'hk-oof.ogg',
    [CHAR_SOUND_OOOF2] = 'hk-oof.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'hk-youweak.ogg',
    [CHAR_SOUND_ON_FIRE] = 'hk-scream.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'hk-rah.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'hk-haah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'hk-smash.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'hk-bowserthrow.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'hk-scream.ogg',
    [CHAR_SOUND_HRMM] = 'hk-grah2.ogg',
    [CHAR_SOUND_WAH2] = 'hk-throw2.ogg',
    [CHAR_SOUND_WHOA] = 'hk-grah2.ogg',
}

local VOICETABLE_DEADPOOL = {
    [CHAR_SOUND_ATTACKED] = 'DP-Motherfucker.ogg',
    [CHAR_SOUND_DOH] = 'DP-Agh.ogg',
    [CHAR_SOUND_DROWNING] = 'DP-Dying.ogg',
    [CHAR_SOUND_DYING] = 'DP-Dying.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'DP-Urgh.ogg',
    [CHAR_SOUND_HAHA] = 'DP-Good.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'DP-Chika.ogg',
    [CHAR_SOUND_HOOHOO] = 'DP-Jump2.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'DP-Bad.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'DP-Chika.ogg',
    [CHAR_SOUND_ON_FIRE] = 'DP-Burning.ogg',
    [CHAR_SOUND_OOOF] = 'DP-Shit.ogg',
    [CHAR_SOUND_OOOF2] = 'DP-Shit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'DP-Urgh.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'DP-Punch3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'DP-Jump1.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'DP-NotFrancis.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'DP-Laugh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'DP-Gored.ogg',
    [CHAR_SOUND_WAH2] = 'DP-Punch2.ogg',
    [CHAR_SOUND_WHOA] = 'DP-Climb.ogg',
    [CHAR_SOUND_YAHOO] = 'DP-Laugh.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'DP-Gotcha.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'DP-Punch2.ogg',
    [CHAR_SOUND_YAWNING] = 'DP-Bored.ogg',
}

local VOICETABLE_VENOM = {
    [CHAR_SOUND_ATTACKED] = 'VM-Dahh.ogg',
    [CHAR_SOUND_DOH] = 'VM-Oof.ogg',
    [CHAR_SOUND_DROWNING] = 'VM-Die.ogg',
    [CHAR_SOUND_DYING] = 'Vm-Die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'VM-Hoo.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'VM-Jump1.ogg',
    [CHAR_SOUND_HOOHOO] = 'VM-Jump2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'VM-Jump3.ogg',
    [CHAR_SOUND_HAHA] = 'VM-Laugh2.ogg',
    [CHAR_SOUND_YAHOO] = 'VM-Long.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'VM-Long.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'VM-Star.ogg',
    [CHAR_SOUND_OOOF] = 'VM-Dahh.ogg',
    [CHAR_SOUND_OOOF2] = 'VM-Dahh.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'VM-Lose.ogg',
    [CHAR_SOUND_ON_FIRE] = 'VM-Burn.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'VM-Yah.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'VM-Wah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'VM-Hoo.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'VM-KillBowser.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'VM-Lahh.ogg',
    [CHAR_SOUND_HRMM] = 'VM-Grab.ogg',
    [CHAR_SOUND_WAH2] = 'VM-Throw.ogg',
    [CHAR_SOUND_WHOA] = 'VM-Lahh.ogg',
    [CHAR_SOUND_YAWNING] = 'VM-Sleep.ogg',
}

local VOICETABLE_DAREDEVIL = {
    [CHAR_SOUND_ATTACKED] = 'DD-Hurt.ogg',
    [CHAR_SOUND_DOH] = 'DD-Oof.ogg',
    [CHAR_SOUND_DROWNING] = 'DD-Dying.ogg',
    [CHAR_SOUND_DYING] = 'DD-Dying.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'DD-FallHit.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'DD-Jump1.ogg',
    [CHAR_SOUND_HOOHOO] = 'DD-Jump2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'DD-Jump3.ogg',
    [CHAR_SOUND_HAHA] = 'DD-OohYeah.ogg',
    [CHAR_SOUND_YAHOO] = 'DD-Yah.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'DD-Yah.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'DD-HalfBad.ogg',
    [CHAR_SOUND_OOOF] = 'DD-FallHit.ogg',
    [CHAR_SOUND_OOOF2] = 'DD-FallHit.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'DD-Lose.ogg',
    [CHAR_SOUND_ON_FIRE] = 'DD-FallHit.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'DD-Yah.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'DD-Wah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'DD-Hoo.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'DD-Guilty.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'DD-HighFall.ogg',
    [CHAR_SOUND_HRMM] = 'DD-Climb.ogg',
    [CHAR_SOUND_WAH2] = 'DD-Jump3.ogg',
    [CHAR_SOUND_WHOA] = 'DD-Climb.ogg',
    [CHAR_SOUND_YAWNING] = 'DD-Sleep.ogg',
}

local PALETTE_SPIDEY = {
    [PANTS]  = "036aa4",
    [SHIRT]  = "ff2027",
    [GLOVES] = "ff2027",
    [SHOES]  = "ff2027",
    [HAIR]   = "2c1d0a",
    [SKIN]   = "fdc8b8",
    [CAP]    = "ff2027",
    [EMBLEM]    = "ff2027",
}

local PALETTE_SYMBIOTE = {
    [PANTS]  = "000017",
    [SHIRT]  = "ff2027",
    [GLOVES] = "ff2027",
    [SHOES]  = "719bff",
    [HAIR]   = "2c1d0a",
    [SKIN]   = "fdc8b8",
    [CAP]    = "ff2027",
    [EMBLEM]    = "ff2027",
}

local PALETTE_BEN = {
    [PANTS]  = "168fff",
    [SHIRT]  = "8d1c1a",
    [GLOVES] = "8d8d8d",
    [SHOES]  = "719bff",
    [HAIR]   = "9e7b41",
    [SKIN]   = "fdc8b8",
    [CAP]    = "ff2027",
    [EMBLEM]    = "ff2027",
}

local PALETTE_BAGMAN = {
    [PANTS]  = "000017",
    [SHIRT]  = "5453ff",
    [GLOVES] = "ff2027",
    [SHOES]  = "719bff",
    [HAIR]   = "0d0c13",
    [SKIN]   = "fdc8b8",
    [CAP]    = "D6B184",
    [EMBLEM]    = "ff2135",
}

local PALETTE_WOLVERINE = {
    [PANTS]  = "0a6aca",
    [SHIRT]  = "fed04f",
    [GLOVES] = "ff2027",
    [SHOES]  = "719bff",
    [HAIR]   = "0d0c13",
    [SKIN]   = "fdc8b8",
    [CAP]    = "D6B184",
    [EMBLEM]    = "ff2027",
}

local PALETTE_BAT = {
    [PANTS]  = "682e17",
    [SHIRT]  = "fe9f4e",
    [GLOVES] = "ff2027",
    [SHOES]  = "719bff",
    [HAIR]   = "0d0c13",
    [SKIN]   = "fdc8b8",
    [CAP]    = "D6B184",
    [EMBLEM]    = "ff2027",
}

local PALETTE_WFORCE = {
    [PANTS]  = "000017",
    [SHIRT]  = "A5A5A5",
    [GLOVES] = "ff2027",
    [SHOES]  = "719bff",
    [HAIR]   = "0d0c13",
    [SKIN]   = "fdc8b8",
    [CAP]    = "D6B184",
    [EMBLEM]    = "000000",
}

local PALETTE_TANK = {
    [PANTS]  = "546a92",
    [SHIRT]  = "fffde6",
    [GLOVES] = "ff2027",
    [SHOES]  = "4b3b36",
    [HAIR]   = "0d0c13",
    [SKIN]   = "fdc8b8",
    [CAP]    = "D6B184",
    [EMBLEM]    = "4b3b36",
}

local PALETTE_HULK = {
    [PANTS]  = "65528D",
    [SHIRT]  = "fffde6",
    [GLOVES] = "ff2027",
    [SHOES]  = "4b3b36",
    [HAIR]   = "0d0c13",
    [SKIN]   = "41AC40",
    [CAP]    = "D6B184",
    [EMBLEM]    = "4b3b36",
}

local PALETTE_GREY = {
    [PANTS]  = "327C9E",
    [SHIRT]  = "fffde6",
    [GLOVES] = "ff2027",
    [SHOES]  = "4b3b36",
    [HAIR]   = "0d0c13",
    [SKIN]   = "86A6B1",
    [CAP]    = "D6B184",
    [EMBLEM]    = "4b3b36",
}

local PALETTE_RED = {
    [PANTS]  = "434948",
    [SHIRT]  = "fffde6",
    [GLOVES] = "ff2027",
    [SHOES]  = "4b3b36",
    [HAIR]   = "0d0c13",
    [SKIN]   = "E82626",
    [CAP]    = "D6B184",
    [EMBLEM]    = "4b3b36",
}

local PALETTE_DEADPOOL = {
    [PANTS]  = "000017",
    [SHIRT]  = "d81c2d",
    [GLOVES] = "d81c2d",
    [SHOES]  = "d81c2d",
    [HAIR]   = "732400",
    [SKIN]   = "fe8e5b",
    [CAP]    = "d81c2d",
    [EMBLEM]    = "d81c2d",
}

local PALETTE_TRAINEE = {
    [PANTS]  = "000017",
    [SHIRT]  = "eed03a",
    [GLOVES] = "d81c2d",
    [SHOES]  = "d81c2d",
    [HAIR]   = "732400",
    [SKIN]   = "fe8e5b",
    [CAP]    = "d81c2d",
    [EMBLEM]    = "d81c2d",
}

local PALETTE_XFORCE = {
    [PANTS]  = "000017",
    [SHIRT]  = "A5A5A5",
    [GLOVES] = "A5A5A5",
    [SHOES]  = "A5A5A5",
    [HAIR]   = "4C4C4C",
    [SKIN]   = "fe8e5b",
    [CAP]    = "A5A5A5",
    [EMBLEM]    = "000017",
}

local PALETTE_BLACK = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "000017",
    [GLOVES] = "000017",
    [SHOES]  = "000017",
    [HAIR]   = "000017",
    [SKIN]   = "fe8e5b",
    [CAP]    = "000017",
    [EMBLEM]    = "000017",
}

local PALETTE_COOLPOOL = {
    [PANTS]  = "000017",
    [SHIRT]  = "e0d8c9",
    [GLOVES] = "4bc9ff",
    [SHOES]  = "4bc9ff",
    [HAIR]   = "732400",
    [SKIN]   = "fe8e5b",
    [CAP]    = "4bc9ff",
    [EMBLEM]    = "4bc9ff",
}

local PALETTE_VENOM = {
    [PANTS]  = "000017",
    [SHIRT]  = "e0d8c9",
    [GLOVES] = "4bc9ff",
    [SHOES]  = "4bc9ff",
    [HAIR]   = "732400",
    [SKIN]   = "000017",
    [CAP]    = "4bc9ff",
    [EMBLEM]    = "4bc9ff",
}

local PALETTE_MVC = {
    [PANTS]  = "4499ee",
    [SHIRT]  = "e0d8c9",
    [GLOVES] = "4bc9ff",
    [SHOES]  = "4bc9ff",
    [HAIR]   = "732400",
    [SKIN]   = "4499ee",
    [CAP]    = "4bc9ff",
    [EMBLEM]    = "4bc9ff",
}

local PALETTE_DAREDEVIL = {
    [PANTS]  = "FF0000",
    [SHIRT]  = "8e0b0d",
    [GLOVES] = "4bc9ff",
    [SHOES]  = "4bc9ff",
    [HAIR]   = "D14A36",
    [SKIN]   = "F6B483",
    [CAP]    = "9A0103",
    [EMBLEM]    = "4bc9ff",
}

local PALETTE_KAM = {
    [PANTS]  = "8e0b0d",
    [SHIRT]  = "FEBA4E",
    [GLOVES] = "FF0000",
    [SHOES]  = "FF0000",
    [HAIR]   = "D14A36",
    [SKIN]   = "F6B483",
    [CAP]    = "FEBA4E",
    [EMBLEM]    = "4bc9ff",
}

local PALETTE_SHADOWLAND = {
    [PANTS]  = "FF0000",
    [SHIRT]  = "000000",
    [GLOVES] = "4bc9ff",
    [SHOES]  = "4bc9ff",
    [HAIR]   = "D14A36",
    [SKIN]   = "F6B483",
    [CAP]    = "000000",
    [EMBLEM]    = "4bc9ff",
}

local HEALTH_METER_SPIDEY = {
    label = {
        left = get_texture_info("hp-back-left"),
        right = get_texture_info("hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("sm-pie-1"),
        [2] = get_texture_info("sm-pie-2"),
        [3] = get_texture_info("sm-pie-3"),
        [4] = get_texture_info("sm-pie-4"),
        [5] = get_texture_info("sm-pie-5"),
        [6] = get_texture_info("sm-pie-6"),
        [7] = get_texture_info("sm-pie-7"),
        [8] = get_texture_info("sm-pie-8"),
    }
}

local HEALTH_METER_WOLVERINE = {
    label = {
        left = get_texture_info("hp-back-left"),
        right = get_texture_info("hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("wv-pie-1"),
        [2] = get_texture_info("wv-pie-2"),
        [3] = get_texture_info("wv-pie-3"),
        [4] = get_texture_info("wv-pie-4"),
        [5] = get_texture_info("wv-pie-5"),
        [6] = get_texture_info("wv-pie-6"),
        [7] = get_texture_info("wv-pie-7"),
        [8] = get_texture_info("wv-pie-8"),
    }
}

local HEALTH_METER_HULK = {
    label = {
        left = get_texture_info("hp-back-left"),
        right = get_texture_info("hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("hk-pie-1"),
        [2] = get_texture_info("hk-pie-2"),
        [3] = get_texture_info("hk-pie-3"),
        [4] = get_texture_info("hk-pie-4"),
        [5] = get_texture_info("hk-pie-5"),
        [6] = get_texture_info("hk-pie-6"),
        [7] = get_texture_info("hk-pie-7"),
        [8] = get_texture_info("hk-pie-8"),
    }
}

local HEALTH_METER_DEADPOOL = {
    label = {
        left = get_texture_info("dp-back-left"),
        right = get_texture_info("dp-back-right"),
    },
    pie = {
        [1] = get_texture_info("dp-pie-1"),
        [2] = get_texture_info("dp-pie-2"),
        [3] = get_texture_info("dp-pie-3"),
        [4] = get_texture_info("dp-pie-4"),
        [5] = get_texture_info("dp-pie-5"),
        [6] = get_texture_info("dp-pie-6"),
        [7] = get_texture_info("dp-pie-7"),
        [8] = get_texture_info("dp-pie-8"),
    }
}

local HEALTH_METER_VENOM = {
    label = {
        left = get_texture_info("vm-back-left"),
        right = get_texture_info("vm-back-right"),
    },
    pie = {
        [1] = get_texture_info("vm-pie-1"),
        [2] = get_texture_info("vm-pie-2"),
        [3] = get_texture_info("vm-pie-3"),
        [4] = get_texture_info("vm-pie-4"),
        [5] = get_texture_info("vm-pie-5"),
        [6] = get_texture_info("vm-pie-6"),
        [7] = get_texture_info("vm-pie-7"),
        [8] = get_texture_info("vm-pie-8"),
    }
}

local HEALTH_METER_DAREDEVIL = {
    label = {
        left = get_texture_info("hp-back-left"),
        right = get_texture_info("hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("dd-pie-1"),
        [2] = get_texture_info("dd-pie-2"),
        [3] = get_texture_info("dd-pie-3"),
        [4] = get_texture_info("dd-pie-4"),
        [5] = get_texture_info("dd-pie-5"),
        [6] = get_texture_info("dd-pie-6"),
        [7] = get_texture_info("dd-pie-7"),
        [8] = get_texture_info("dd-pie-8"),
    }
}

local CSloaded = false
local function on_character_select_load()
    CT_SPIDEY = _G.charSelect.character_add("Spider-Man", "The amazing wall-crawler!", "Chief's Hairline", {r = 255, g = 0, b = 0}, E_MODEL_SPIDEY, CT_MARIO, TEX_SM_LIFE_ICON)
    CT_WOLVERINE = _G.charSelect.character_add("Wolverine", "Weapon X!", "Chief's Hairline", {r = 254, g = 208, b = 79}, E_MODEL_WOLVERINE, CT_MARIO, TEX_WV_LIFE_ICON)
    CT_HULK = _G.charSelect.character_add("Hulk", "The jade giant!", "Cookie Eater", {r = 65, g = 172, b = 64}, E_MODEL_HULK, CT_MARIO, TEX_HK_LIFE_ICON)
    CT_DEADPOOL = _G.charSelect.character_add("Deadpool", "The merc with the mouth!", "Chief's Hairline", {r = 255, g = 0, b = 0}, E_MODEL_DEADPOOL, CT_MARIO, TEX_DP_LIFE_ICON)
    CT_VENOM = _G.charSelect.character_add("Venom", "The lethal protector!", "Chief's Hairline", {r = 255, g = 255, b = 255}, E_MODEL_VENOM, CT_MARIO, TEX_VM_LIFE_ICON)
    CT_DAREDEVIL = _G.charSelect.character_add("Daredevil", "The man without fear!", "Chief's Hairline", {r = 255, g = 0, b = 0}, E_MODEL_DAREDEVIL, CT_MARIO, TEX_DD_LIFE_ICON)

    _G.charSelect.character_add_voice(E_MODEL_SPIDEY, VOICETABLE_SPIDEY)
    _G.charSelect.character_add_voice(E_MODEL_SYMBIOTE, VOICETABLE_SPIDEY)
    _G.charSelect.character_add_voice(E_MODEL_BEN, VOICETABLE_SPIDEY)
    _G.charSelect.character_add_voice(E_MODEL_BAGMAN, VOICETABLE_SPIDEY)

    _G.charSelect.character_add_voice(E_MODEL_WOLVERINE, VOICETABLE_WOLVERINE)
    _G.charSelect.character_add_voice(E_MODEL_BAT, VOICETABLE_WOLVERINE)
    _G.charSelect.character_add_voice(E_MODEL_WFORCE, VOICETABLE_WOLVERINE)
    _G.charSelect.character_add_voice(E_MODEL_TANK, VOICETABLE_WOLVERINE)

    _G.charSelect.character_add_voice(E_MODEL_HULK, VOICETABLE_HULK)
    _G.charSelect.character_add_voice(E_MODEL_GREY, VOICETABLE_HULK)
    _G.charSelect.character_add_voice(E_MODEL_RED, VOICETABLE_HULK)

    _G.charSelect.character_add_voice(E_MODEL_DEADPOOL, VOICETABLE_DEADPOOL)
    _G.charSelect.character_add_voice(E_MODEL_TRAINEE, VOICETABLE_DEADPOOL)
    _G.charSelect.character_add_voice(E_MODEL_XFORCE, VOICETABLE_DEADPOOL)
    _G.charSelect.character_add_voice(E_MODEL_COOLPOOL, VOICETABLE_DEADPOOL)
    _G.charSelect.character_add_voice(E_MODEL_BLACK, VOICETABLE_DEADPOOL)

    _G.charSelect.character_add_voice(E_MODEL_VENOM, VOICETABLE_VENOM)
    _G.charSelect.character_add_voice(E_MODEL_MVC, VOICETABLE_VENOM)

    _G.charSelect.character_add_voice(E_MODEL_DAREDEVIL, VOICETABLE_DAREDEVIL)
    _G.charSelect.character_add_voice(E_MODEL_KAM, VOICETABLE_DAREDEVIL)
    _G.charSelect.character_add_voice(E_MODEL_SHADOWLAND, VOICETABLE_DAREDEVIL)


    _G.charSelect.character_add_celebration_star(E_MODEL_DEADPOOL, E_MODEL_CHIMICHANGA, TEX_DP_STAR_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_TRAINEE, E_MODEL_CHIMICHANGA, TEX_DP_STAR_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_XFORCE, E_MODEL_CHIMICHANGA, TEX_DP_STAR_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_BLACK, E_MODEL_CHIMICHANGA, TEX_DP_STAR_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_COOLPOOL, E_MODEL_CHIMICHANGA, TEX_DP_STAR_ICON)

    _G.charSelect.character_add_palette_preset(E_MODEL_SPIDEY, PALETTE_SPIDEY)
    _G.charSelect.character_add_palette_preset(E_MODEL_SYMBIOTE, PALETTE_SYMBIOTE)
    _G.charSelect.character_add_palette_preset(E_MODEL_BEN, PALETTE_BEN)
    _G.charSelect.character_add_palette_preset(E_MODEL_BAGMAN, PALETTE_BAGMAN)

    _G.charSelect.character_add_palette_preset(E_MODEL_WOLVERINE, PALETTE_WOLVERINE)
    _G.charSelect.character_add_palette_preset(E_MODEL_BAT, PALETTE_BAT)
    _G.charSelect.character_add_palette_preset(E_MODEL_WFORCE, PALETTE_WFORCE)
    _G.charSelect.character_add_palette_preset(E_MODEL_TANK, PALETTE_TANK)

    _G.charSelect.character_add_palette_preset(E_MODEL_HULK, PALETTE_HULK)
    _G.charSelect.character_add_palette_preset(E_MODEL_GREY, PALETTE_GREY)
    _G.charSelect.character_add_palette_preset(E_MODEL_RED, PALETTE_RED)

    _G.charSelect.character_add_palette_preset(E_MODEL_DEADPOOL, PALETTE_DEADPOOL)
    _G.charSelect.character_add_palette_preset(E_MODEL_TRAINEE, PALETTE_TRAINEE)
    _G.charSelect.character_add_palette_preset(E_MODEL_XFORCE, PALETTE_XFORCE)
    _G.charSelect.character_add_palette_preset(E_MODEL_BLACK, PALETTE_BLACK)
    _G.charSelect.character_add_palette_preset(E_MODEL_COOLPOOL, PALETTE_COOLPOOL)

    _G.charSelect.character_add_palette_preset(E_MODEL_VENOM, PALETTE_VENOM)
    _G.charSelect.character_add_palette_preset(E_MODEL_MVC, PALETTE_MVC)

    _G.charSelect.character_add_palette_preset(E_MODEL_DAREDEVIL, PALETTE_DAREDEVIL)
    _G.charSelect.character_add_palette_preset(E_MODEL_KAM, PALETTE_KAM)
    _G.charSelect.character_add_palette_preset(E_MODEL_SHADOWLAND, PALETTE_SHADOWLAND)

    _G.charSelect.character_add_health_meter(CT_SPIDEY, HEALTH_METER_SPIDEY)

    _G.charSelect.character_add_health_meter(CT_WOLVERINE, HEALTH_METER_WOLVERINE)

    _G.charSelect.character_add_health_meter(CT_HULK, HEALTH_METER_HULK)

    _G.charSelect.character_add_health_meter(CT_DEADPOOL, HEALTH_METER_DEADPOOL)

    _G.charSelect.character_add_health_meter(CT_VENOM, HEALTH_METER_VENOM)

    _G.charSelect.character_add_health_meter(CT_DAREDEVIL, HEALTH_METER_DAREDEVIL)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SPIDEY then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_WOLVERINE then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_HULK then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_DEADPOOL then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_VENOM then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_DAREDEVIL then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SPIDEY then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_WOLVERINE then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_HULK then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_DEADPOOL then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_VENOM then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_DAREDEVIL then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)

--------------------------------------------
--- Alt Costume code from Paper Partners ---
------------ Thanks, Melzinoff!! -----------
--------- Original code by Wibblus!! -------
--------------------------------------------

local CUR_SKIN_SPIDEY = 1
-- table of skins
local SKINTABLE_SPIDEY = {
    { model = E_MODEL_SPIDEY,  name = "Spider-Man", desc = "The amazing wall-crawler!", credit = "Chief's Hairline", color = {r = 250, g = 0, b = 0}, E_MODEL_SPIDEY, CT_MARIO, TEX_SM_LIFE_ICON},
    { model = E_MODEL_SYMBIOTE,  name = "Symbiote Suit", desc = "Nifty new costume found on Battle World!", credit = "Chief's Hairline", color = {r = 113, g = 155, b = 255}, E_MODEL_SYMBIOTE, CT_MARIO, TEX_SM_LIFE_ICON},
    { model = E_MODEL_BEN,  name = "Scarlet Spider", desc = "Brother... from another mother..?", credit = "Chief's Hairline", color = {r = 115, g = 6, b = 0}, E_MODEL_BEN, CT_MARIO, TEX_SM_LIFE_ICON},
    { model = E_MODEL_BAGMAN,  name = "Bag-Man", desc = "A favor from your good pal Johnny!", credit = "Chief's Hairline", color = {r = 214, g = 177, b = 132}, E_MODEL_BAGMAN, CT_MARIO, TEX_SM_LIFE_ICON},
}

local function update_character_skin()
    local curSpideySkin = SKINTABLE_SPIDEY[CUR_SKIN_SPIDEY]
    _G.charSelect.character_edit(CT_SPIDEY, curSpideySkin.name, curSpideySkin.desc, curSpideySkin.credit, curSpideySkin.color, curSpideySkin.model, nil, curSpideySkin[6], nil)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_SPIDEY then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_SPIDEY < #SKINTABLE_SPIDEY then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_SPIDEY = CUR_SKIN_SPIDEY + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_SPIDEY > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_SPIDEY = math.max(CUR_SKIN_SPIDEY - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)

local CUR_SKIN_WOLVERINE = 1
-- table of skins
local SKINTABLE_WOLVERINE = {
    { model = E_MODEL_WOLVERINE,  name = "Wolverine", desc = "Weapon X!", credit = "Chief's Hairline", color = {r = 254, g = 208, b = 79}, E_MODEL_WOLVERINE, CT_MARIO, TEX_WV_LIFE_ICON},
    { model = E_MODEL_BAT,  name = "Brown-and-Tan", desc = "What did you expect? Black leather?", credit = "Chief's Hairline", color = {r = 104, g = 46, b = 23}, E_MODEL_BAT, CT_MARIO, TEX_WV_LIFE_ICON},
    { model = E_MODEL_WFORCE,  name = "X-Force", desc = "For special missions only!", credit = "Chief's Hairline", color = {r = 254, g = 253, b = 228}, E_MODEL_WFORCE, CT_MARIO, TEX_WV_LIFE_ICON},
    { model = E_MODEL_TANK,  name = "Tanktop Casual", desc = "Zip it, bub. I'm off duty.", credit = "Chief's Hairline", color = {r = 255, g = 253, b = 230}, E_MODEL_TANK, CT_MARIO, TEX_WV_LIFE_ICON},
}

local function update_character_skin()
    local curWolverineSkin = SKINTABLE_WOLVERINE[CUR_SKIN_WOLVERINE]
    _G.charSelect.character_edit(CT_WOLVERINE, curWolverineSkin.name, curWolverineSkin.desc, curWolverineSkin.credit, curWolverineSkin.color, curWolverineSkin.model, nil, curWolverineSkin[6], nil)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_WOLVERINE then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_WOLVERINE < #SKINTABLE_WOLVERINE then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_WOLVERINE = CUR_SKIN_WOLVERINE + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_WOLVERINE > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_WOLVERINE = math.max(CUR_SKIN_WOLVERINE - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)

local CUR_SKIN_HULK = 1
-- table of skins
local SKINTABLE_HULK = {
    { model = E_MODEL_HULK,  name = "Hulk", desc = "The jade giant!", credit = "Cookie Eater", color = {r = 65, g = 172, b = 64}, E_MODEL_HULK, CT_MARIO, TEX_HK_LIFE_ICON},
    { model = E_MODEL_GREY,  name = "Gamma Radiated", desc = "The original look!", credit = "Cookie Eater", color = {r = 134, g = 166, b = 177}, E_MODEL_GREY, CT_MARIO, TEX_HK_LIFE_ICON},
    { model = E_MODEL_RED,  name = "Red Hulk", desc = "The beastly form of Thunderbolt Ross!", credit = "Cookie Eater", color = {r = 243, g = 41, b = 37}, E_MODEL_RED, CT_MARIO, TEX_HK_LIFE_ICON},
}

local function update_character_skin()
    local curHulkSkin = SKINTABLE_HULK[CUR_SKIN_HULK]
    _G.charSelect.character_edit(CT_HULK, curHulkSkin.name, curHulkSkin.desc, curHulkSkin.credit, curHulkSkin.color, curHulkSkin.model, nil, curHulkSkin[6], nil)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_HULK then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_HULK < #SKINTABLE_HULK then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_HULK = CUR_SKIN_HULK + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_HULK > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_HULK = math.max(CUR_SKIN_HULK - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)

local CUR_SKIN_DEADPOOL = 1
-- table of skins
local SKINTABLE_DEADPOOL = {
    { model = E_MODEL_DEADPOOL,  name = "Deadpool", desc = "The merc with the mouth!", credit = "Chief's Hairline", color = {r = 250, g = 0, b = 0}, E_MODEL_DEADPOOL, CT_MARIO, TEX_DP_LIFE_ICON},
    { model = E_MODEL_TRAINEE,  name = "X-Men Trainee", desc = "Honorary!", credit = "Chief's Hairline", color = {r = 238, g = 208, b = 58}, E_MODEL_TRAINEE, CT_MARIO, TEX_DP_LIFE_ICON},
    { model = E_MODEL_XFORCE,  name = "X-Force", desc = "For special missions only!", credit = "Chief's Hairline", color = {r = 254, g = 253, b = 228}, E_MODEL_XFORCE, CT_MARIO, TEX_DP_LIFE_ICON},
    { model = E_MODEL_BLACK,  name = "Back in Black", desc = "Spidey's got nothing on these digs!", credit = "Chief's Hairline", color = {r = 255, g = 255, b = 255}, E_MODEL_BLACK, CT_MARIO, TEX_DP_LIFE_ICON},
    { model = E_MODEL_COOLPOOL,  name = "Coolpool", desc = "Who else but Coolpool?", credit = "Chief's Hairline", color = {r = 75, g = 201, b = 255}, E_MODEL_COOLPOOL, CT_MARIO, TEX_DP_LIFE_ICON},
}

local function update_character_skin()
    local curDeadpoolSkin = SKINTABLE_DEADPOOL[CUR_SKIN_DEADPOOL]
    _G.charSelect.character_edit(CT_DEADPOOL, curDeadpoolSkin.name, curDeadpoolSkin.desc, curDeadpoolSkin.credit, curDeadpoolSkin.color, curDeadpoolSkin.model, nil, curDeadpoolSkin[6], nil)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_DEADPOOL then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_DEADPOOL < #SKINTABLE_DEADPOOL then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_DEADPOOL = CUR_SKIN_DEADPOOL + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_DEADPOOL > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_DEADPOOL = math.max(CUR_SKIN_DEADPOOL - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)

local CUR_SKIN_VENOM = 1
-- table of skins
local SKINTABLE_VENOM = {
    { model = E_MODEL_VENOM,  name = "Venom", desc = "The lethal protector!", credit = "Chief's Hairline", color = {r = 250, g = 250, b = 250}, E_MODEL_VENOM, CT_MARIO, TEX_VM_LIFE_ICON},
    { model = E_MODEL_MVC,  name = "MVC Blue", desc = "You nerds wanted it!", credit = "Chief's Hairline", color = {r = 68, g = 204, b = 255}, E_MODEL_MVC, CT_MARIO, TEX_VM_LIFE_ICON},
}

local function update_character_skin()
    local curVenomSkin = SKINTABLE_VENOM[CUR_SKIN_VENOM]
    _G.charSelect.character_edit(CT_VENOM, curVenomSkin.name, curVenomSkin.desc, curVenomSkin.credit, curVenomSkin.color, curVenomSkin.model, nil, curVenomSkin[6], nil)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_VENOM then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_VENOM < #SKINTABLE_VENOM then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_VENOM = CUR_SKIN_VENOM + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_VENOM > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_VENOM = math.max(CUR_SKIN_VENOM - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)

local CUR_SKIN_DAREDEVIL = 1
-- table of skins
local SKINTABLE_DAREDEVIL = {
    { model = E_MODEL_DAREDEVIL,  name = "Daredevil", desc = "The man without fear!", credit = "Chief's Hairline", color = {r = 250, g = 0, b = 0}, E_MODEL_DAREDEVIL, CT_MARIO, TEX_DD_LIFE_ICON},
    { model = E_MODEL_KAM,  name = "Classic", desc = "Good ole ketchup and mustard!", credit = "Chief's Hairline", color = {r = 254, g = 186, b = 0}, E_MODEL_KAM, CT_MARIO, TEX_DD_LIFE_ICON},
    { model = E_MODEL_SHADOWLAND,  name = "Shadowland", desc = "The devil returns to Hell's Kitchen!", credit = "Chief's Hairline", color = {r = 250, g = 0, b = 0}, E_MODEL_SHADOWLAND, CT_MARIO, TEX_DD_LIFE_ICON},
}

local function update_character_skin()
    local curDaredevilSkin = SKINTABLE_DAREDEVIL[CUR_SKIN_DAREDEVIL]
    _G.charSelect.character_edit(CT_DAREDEVIL, curDaredevilSkin.name, curDaredevilSkin.desc, curDaredevilSkin.credit, curDaredevilSkin.color, curDaredevilSkin.model, nil, curDaredevilSkin[6], nil)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_DAREDEVIL then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_DAREDEVIL < #SKINTABLE_DAREDEVIL then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_DAREDEVIL = CUR_SKIN_DAREDEVIL + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_DAREDEVIL > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_DAREDEVIL = math.max(CUR_SKIN_DAREDEVIL - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)